# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 Akretion LDTA (<http://www.akretion.com>).
#    @author Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv

class project_phase(osv.osv):
    _inherit = "project.phase"
    
    #FIXME won't work if write happens on the project instead -> go hell OpenERP!
    def write(self, cr, uid, ids, vals, context=None): #update of usability value when modifying duration of the phase
        res = super(project_phase, self).write(cr, uid, ids, vals, context)
        if vals.get('duration', False):
            for phase in self.browse(cr, uid, ids):
                for resource in phase.resource_ids:
                    self.pool.get('project.resource.allocation').write(cr, uid, resource.id, {'useability': resource.load_duration/phase.duration*100}, context)
        return res
project_phase()
         
class project_resource_allocation(osv.osv):
    _inherit = 'project.resource.allocation'           
    _columns = {
        'load_duration': fields.float('Load Duration in Days'),
    }
    
    def _get_load_duration(self, cr, uid, context={}):
        if context.get('duration', False):
            return context.get('duration')
        else:
            return False
    
    _defaults = {
        'load_duration': _get_load_duration,
    }
project_resource_allocation()
